#include <windows.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <io.h>
#include <sys\types.h>
#include <sys\timeb.h>
#include <sys\utime.h>
#include <sys\stat.h>
#include "exports.h"
#include "cwstart.h"
#include "cwdialog.h"
#include "addfx.h"


// ***************************************************************************
//
// Mike Bailey 16 Feb 96 12:49a
// Update to work with CW 4.0 in 32-bit mode.
//
// Mike Bailey 12 Oct 95 9:39p
// Code follows.  Note that this DLL should be added to the
// preload section of the CWRIGHT.INI file, as shown:
//
//      [LibPreLoad]
//      LibPreload=addfx.dll
//
// If any of these functions are needed in another DLL, link the ADDFX.LIB
// during a MAKE.
// The make file has not been modified to look in the 16 bit or 32 bit 
// library directories, but only in the root of the CW lib directory.
//
// ***************************************************************************
//


// Mike Bailey 30 Jan 95 7:27p
// Insert full name and timedate stamp.
//
// A "FullName=" entry is looked for in a [InsertName] section in
// the ADDFIX.INI file first.
//
void DLL MHB_InsertName (void)                  // shift-f8
{
    char msg[128];
    char cName[128];
    char ampm[] = "a";
    char month[4];
    time_t ltime;
    struct tm *tt;
    long colSave, lineSave;
    int iReturn;
    char  fName[128];
    char  pathName[128];
    LPSTR ptr = fName;
   

    time (&ltime);
    tt = localtime( &ltime);
    if (tt->tm_hour > 11)
    {
        strcpy (ampm, "p");
    }
    if (tt->tm_hour >= 13)
    {
        tt->tm_hour -= 12;
    }
   
    switch (tt->tm_mon)
    {
       case  0: strcpy (month, "Jan");
                break;
       case  1: strcpy (month, "Feb");
                break;
       case  2: strcpy (month, "Mar");
                break;
       case  3: strcpy (month, "Apr");
                break;
       case  4: strcpy (month, "May");
                break;
       case  5: strcpy (month, "Jun");
                break;
       case  6: strcpy (month, "Jul");
                break;
       case  7: strcpy (month, "Aug");
                break;
       case  8: strcpy (month, "Sep");
                break;
       case  9: strcpy (month, "Oct");
                break;
       case 10: strcpy (month, "Nov");
                break;
       case 11: strcpy (month, "Dec");
    }
   
    colSave = BufQCurrentCol();
    lineSave = BufQCurrentLine();
    lineSave++;

    // Mike Bailey 18 Oct 95 8:48p 
    // Create fully-qualified path to ini file in the CWRIGHT directory.
    //
    ptr = TransformFilename (SysQArgv (0), "%v%p");
    wsprintf (pathName, "%saddfx.ini", ptr);

    iReturn = GetPrivateProfileString((LPCSTR)"InsertName", (LPCSTR)"FullName",
                              "", cName, sizeof (cName), (LPCSTR)pathName);

    if (iReturn > 0)
         wsprintf (msg, "// %s %d %s %d %d:%02d%s\r\n", cName, tt->tm_mday,
                 month, tt->tm_year, tt->tm_hour, tt->tm_min, ampm);
    else
         wsprintf (msg, "// Mike Bailey %d %s %d %d:%02d%s\r\n", tt->tm_mday,
                 month, tt->tm_year, tt->tm_hour, tt->tm_min, ampm);


    BufInsertStr(msg);

    if (colSave != 0)
    MovAbs (lineSave, colSave);
    BufInsertStr ("// ");
}


// Mike Bailey 12 Oct 95 7:06p 
// Insert initials and timedate stamp.
// An "Initials=" entry is looked for in a [InsertName] section in
// the ADDFIX.INI file first.
//
void DLL MHB_InsertInitials (void)              // shift-f7
{
    char msg[128];
    char cName[128];
    long colSave, lineSave;
    int iReturn;
    char  fName[128];
    char  pathName[128];
    LPSTR ptr = fName;
   
    colSave = BufQCurrentCol();
    lineSave = BufQCurrentLine();
    lineSave++;
    
    // Mike Bailey 18 Oct 95 8:48a 
    // Create fully-qualified path to ini file in the CWRIGHT directory.
    //
    ptr = TransformFilename (SysQArgv (0), "%v%p");
    wsprintf (pathName, "%saddfx.ini", ptr);

    iReturn = GetPrivateProfileString((LPCSTR)"InsertName", (LPCSTR)"Initials",
                               "", cName, sizeof (cName), (LPCSTR)pathName);
    
    if (iReturn > 0)
        wsprintf(msg, "//%s ", cName);
    else
        wsprintf(msg, "//mhb ");

    BufInsertStr(msg);
    MHB_DisplayFileName();
    MovAbs (lineSave, colSave);
}


// Mike Bailey 15 Feb 95 12:29a Add command to do a DOS Window Shell so
// a specific PIF file can be called in order to resize the window
// correctly.
//
void DLL MHB_DosWindow (void)                 // ALT-Z
{
    int   retcode;

    retcode = WinExec( "CWWINDOW.PIF", SW_SHOWMAXIMIZED);
    MHB_DisplayFileName();
}


// Mike Bailey 9 Oct 95 9:55p Attach to ALT-M to do makes.
//
void DLL MHB_DosMake ( void )                   // ALT-M
{
    int   retcode;

    BufWrite();
    retcode = WinExec( "CWMAKE.PIF", SW_SHOWMAXIMIZED);
    MHB_DisplayFileName();
}


void DLL MHB_GoToBookmark1 (void)               // shift-f1
{
    LPSTR   response = NIL;
    MarkID  mark_num;


    mark_num = (MarkID)MAKE_GLOBAL_MARKID( 1 );
    if ( MarkQInUse( mark_num ) )
    {
        MarkGoto(mark_num);
        CenterLine();
        MovAbs (BufQCurrentLine(), 1);
        MHB_DisplayFileName();
    }
    else
        MsgMessage( "Bookmark one doesn't exist." );
}


void DLL MHB_GoToBookmark2 (void)               // shift-f2
{
    LPSTR   response = NIL;
    MarkID  mark_num;


    mark_num = (MarkID)MAKE_GLOBAL_MARKID( 2 );
    if ( MarkQInUse( mark_num ) )
    {
        MarkGoto(mark_num);
        CenterLine();
        MovAbs (BufQCurrentLine(), 1);
        MHB_DisplayFileName();
    }
    else
        MsgMessage( "Bookmark two doesn't exist." );
}


void DLL MHB_GoToBookmark3 (void)               // shift-f3
{
    LPSTR   response = NIL;
    MarkID  mark_num;


    mark_num = (MarkID)MAKE_GLOBAL_MARKID( 3 );
    if ( MarkQInUse( mark_num ) )
    {
        MarkGoto(mark_num);
        CenterLine();
        MovAbs (BufQCurrentLine(), 1);
        MHB_DisplayFileName();
    }
    else
        MsgMessage( "Bookmark three doesn't exist." );
}

// Mike Bailey 7 Nov 95 9:23p
// Remove the line count since this is put on a timer and adds a lot
// of undo information as it always drops to the end of the buffer to
// get a line count.
//
void DLL MHB_DisplayFileName (void)
{
    LPSTR name, tmpname;
    struct _finddata_t find;
    char datebuf [64];
    char cFileData[256];
    char namebuf[512];

    // compute the buffer's name
    if (((tmpname = BufQOutputName()) != NIL) && (*tmpname != '\0'))
        ;
    else if (((tmpname = BufQName()) != NIL) && (*tmpname != '\0'))
        ;
    else if (((tmpname = BufQFilename()) != NIL) && (*tmpname != '\0'))
        ;
    else
        tmpname = "  <untitled>";

    // Mike Bailey 7 Nov 95 9:46p 
    // Transform to filename (root and extension).
    //
    (LPSTR)name = (LPSTR)TransformFilename ((LPSTR)tmpname, (LPSTR)"%r%e");
    // Mike Bailey 31 Jan 95 8:37p Get the file info.
    //
    if (_findfirst (tmpname, &find ) != -1L)
    {
        memset (datebuf,  0x00, sizeof(datebuf));
        memset (cFileData, 0x00, sizeof(cFileData));
        wsprintf (datebuf, "%s", ctime (&find.time_write));
        *(datebuf+strlen(datebuf)-1) = 0x00;
        wsprintf (cFileData, "%s %ld %s", name, find.size, datebuf);
    }
    else                                // Couldn't get info on file or buffer.
    {
        wsprintf (cFileData,"%s", name); 
    }    

    (LPSTR)name = (LPSTR)TransformFilename ((LPSTR)tmpname, (LPSTR)"%v%d");

    wsprintf (namebuf, "%s\\%s", name, cFileData);
    SetWindowText(WinQHFrame(), "CW");
    SetWindowText(WinQHCurrent(), namebuf);
}


// Mike Bailey 7 Nov 95 7:31p
// Use to display current working directory.
//
void DLL MHB_CurDir (void)
{
    char cBuf[128];
    MsgLevel(0);
    wsprintf (cBuf, "cwd: %s", SysQCwd(0));
    MsgMessage(cBuf);
}


// Mike Bailey 7 Nov 95 9:26p
// Use to also get the number of lines in the file. NOT attached to a 
// timer.
//
void DLL MHB_DisplayFileStats (void)        // CRTL-L
{
    LPSTR name, tmpname;
    struct _finddata_t find;
    char datebuf [64];
    char cFileData[256];
    char namebuf[512];
    long totlines=0;
    long colSave, lineSave;

    MsgLevel(0);

    colSave = BufQCurrentCol();
    lineSave = BufQCurrentLine();

    // compute the buffer's name
    if (((tmpname = BufQOutputName()) != NIL) && (*tmpname != '\0'))
        ;
    else if (((tmpname = BufQName()) != NIL) && (*tmpname != '\0'))
        ;
    else if (((tmpname = BufQFilename()) != NIL) && (*tmpname != '\0'))
        ;
    else
        tmpname = "  <untitled>";

    (LPSTR)name = (LPSTR)TransformFilename ((LPSTR)tmpname, (LPSTR)"%r%e");
    // Mike Bailey 31 Jan 93 8:37p Get the file info.
    //
    if (_findfirst (tmpname, &find ) != -1L)
    {
        wsprintf (datebuf, "%s", ctime (&find.time_write));
        *(datebuf+strlen(datebuf)-1) = 0x00;
        MarkSavePos();
        MovEOF();
        totlines = BufQCurrentLine();
        MarkRestorePos();
        memset (cFileData, 0x00, sizeof (cFileData));
        wsprintf (cFileData, "%s %ld %ld %s ", name, totlines, find.size, datebuf);
    }
    else                                // Couldn't get info on file or buffer.
    {
        MarkSavePos();
        MovEOF();
        totlines = BufQCurrentLine();
        MarkRestorePos();
        memset (cFileData, 0x00, sizeof (cFileData));
        wsprintf (cFileData,"%s %d", name, totlines); 
    }
    
    wsprintf (namebuf, 
    "%s", cFileData);
    MsgMessage (namebuf);
    MovAbs (lineSave, colSave);
}


// Mike Bailey 19 Oct 95 9:19p
// Dialog to display the current working directory
// and to select a file.
//
void DLL dir (LPSTR szWildCard)
{
    LPSTR p;
    LPSTR file;
    char c;
    LPSTR curdir;
    LPSTR fname;
    char dir[260];
    char szFile[260];

    file = szFile;
    fname = szWildCard;

    // Display the current working directory.
    //
    if (!szWildCard || !*szWildCard)
        DlgOpenFile (WinQHCurrent());
    else
    {
        curdir = SysQCwd(0);
        curdir = STRLWR( curdir ? curdir : StrNew(""));

        *file = *dir = '\0';
        if ((fname == NIL) || (*fname == '\0'))
            fname = BufQFilename();

        if ((fname != NIL) && (*fname != '\0'))
        {
            /* separate the filename into directory/root */
            STRCPY (dir, fname);
            for (p = dir + STRLEN(dir) - 1; p != dir; p--)
            {
                if (((c = *p) == '\\') || (c == '/'))
                {
                    *p++ = '\0';
                    break;
                }
                else if (c == ':')
                {
                    p++;
                    break;
                }
            }

            STRCPY(file, p);
            *p = '\0';

            if ((SysQFlags() & SYSFLAG_NON_DOS_FILENAMES) == 0)
            {
                /* convert filename to 8.3 format */
                for (p = file; (*p != '\0') && (*p != '.'); p++)
                    ;
                if ((p - file) > 8)
                {
                    /* delete extra filename characters */
                    STRCPY(file + 8, p);
                    p = file + 8;
                }
                if ((*p == '.') && (STRLEN(p) > 4))
                    /* truncate the extension */
                    p[4] = '\0';
            }

            SysSetCwd (dir);
        DlgOpenFile (WinQHCurrent());
        }
    }

    MHB_DisplayFileName();
    MHB_CurDir();
}


// Mike Bailey 19 Oct 95 9:19p
// Change directories.
//
void DLL cd (LPSTR szPath)
{
    LPSTR szNewPath;

    szNewPath = MsgPopupPromptHistory ("DIRECTORY", "Dir Change: ", szPath);

    if (!szNewPath || !*szNewPath)
    {
        MHB_DisplayFileName();
        return;
    }

    SysSetCwd (szNewPath);
    MHB_DisplayFileName();
    MHB_CurDir();
}
                      

// Mike Bailey 11 Oct 95 10:45p 
// This provides shortcut directory changes.
// The entries are saved in a ADDFX.INI file which resides in the Windows
// directory. The PIF file is a standard Windows PIF file that executes
// COMMAND.COM in the current working directory, which is also set here.
// The function needs to be attached to a keystroke either via the Key item
// on the menu bar or to the [KmapAssign] secton in the CWRIGHT.INI file,
// such as: KmapAssign='<F12>' 'MHB_ShellCmd'.
// 
// Note:  the ADDFX.INI file can be modified with an ASCII editor to 
// setup the initial shortcuts.
//
void DLL MHB_DirChange (void)                   // ALT-T
{
    LPSTR szShortCutPath;
    LPSTR szFullDirPath;
    char  cFullDirPath[128];
    char  fName[128];
    char  pathName[128];
    BOOL bNew = FALSE;
    LPSTR ptr = fName;
    LPSTR pattern = _GetHistoryTOS( "DIRECTORY" );

    szShortCutPath = MsgPopupPromptHistory ("DIRECTORY",
                                            "Dir change using a shortcut: ",
                                            pattern);

    if (!szShortCutPath || !*szShortCutPath)
    {
        return;
        MsgMessage( "" );
    }

    // Mike Bailey 18 Oct 95 8:48p 
    // Create fully-qualified path to ini file in the CWRIGHT directory.
    //
    ptr = TransformFilename (SysQArgv (0), "%v%p");
    wsprintf (pathName, "%saddfx.ini", ptr);

    if (strnicmp (szShortCutPath, "?", 1) == 0)
    {
        BufEditFile (pathName);
        MHB_DisplayFileName();
        MHB_CurDir();
        return;
    }

    if (strnicmp (szShortCutPath, "addshort", 8) == 0)
    {
        szShortCutPath = MsgPrompt ("Short cut: ", "", "");
        if (!szShortCutPath || !*szShortCutPath)
            return;
        szFullDirPath = MsgPrompt ("Full path: ", "", "");
        if (!szFullDirPath || !*szFullDirPath)
            return;

        // Mike Bailey 8 Nov 95 10:26p 
        // Use current working directory as the path.
        //
        if ((strnicmp(szFullDirPath, ".", 1) == 0) ||
            (strnicmp(szFullDirPath, "CWD", 3) == 0))
        {
            lstrcpyn (cFullDirPath, SysQCwd(0), sizeof(cFullDirPath));
            szFullDirPath = cFullDirPath;
        }
        WritePrivateProfileString((LPCSTR)"DirChange", (LPCSTR)szShortCutPath,
                              (LPCSTR)szFullDirPath, (LPCSTR)pathName);
        bNew = TRUE;
    }
    else
        GetPrivateProfileString((LPCSTR)"DirChange", (LPCSTR)szShortCutPath,
                              "", cFullDirPath, sizeof (cFullDirPath),
                              (LPCSTR)pathName);

    if (bNew == TRUE)
        SysSetCwd (szFullDirPath);
    else
        SysSetCwd (cFullDirPath);

    BR_edit_file ();
    MHB_DisplayFileName();
    MHB_CurDir();
}


// Mike Bailey 11 Oct 95 10:46p 
//
// Shortcut to a shell out path.  Uses the same INI
// file as the MHB_DirChange function, ADDFX.INI, which is kept in the
// Windows directory by default.  The PIF file is a standard Windows PIF
// file that executes COMMAND.COM in the current working directory, which
// is also set here.
// The function needs to be attached to a keystroke either via the Key item
// on the menu bar or to the [KmapAssign] secton in the CWRIGHT.INI file,
// such as: KmapAssign='<F12>' 'MHB_ShellCmd'.
//
// Note:  the ADDFX.INI file can be modified with an ASCII editor to 
// setup the initial shortcuts.

void DLL MHB_ShellCMD (void)                    // ALT-S
{
    int   retcode;
    LPSTR szShortCutPath;
    LPSTR szFullDirPath;
    char  cFullDirPath[128];
    BOOL bNew = FALSE;
    int iReturn;
    char  fName[128];
    char  pathName[128];
    LPSTR ptr = fName;
    LPSTR pattern = _GetHistoryTOS( "DOSHISTORY" );

    szShortCutPath = MsgPopupPromptHistory ("DOSHISTORY",
                                            "Dir shell using a shortcut: ",
                                            pattern);

    if (!szShortCutPath || !*szShortCutPath)
    {
        return;
        MsgMessage( "" );
    }

    // Mike Bailey 18 Oct 95 8:48p 
    // Create fully-qualified path to ini file in the CWRIGHT directory.
    //
    ptr = TransformFilename (SysQArgv (0), "%v%p");
    wsprintf (pathName, "%saddfx.ini", ptr);

    if (strnicmp (szShortCutPath, "?", 1) == 0)
    {
        BufEditFile (pathName);
        MsgMessage( "" );
        MHB_DisplayFileName();
        return;
    }

    iReturn = strnicmp (szShortCutPath, "addshort", 8);
    if (iReturn == 0)
    {
        szShortCutPath = MsgPrompt ("Short cut: ", "", "");
        if (!szShortCutPath || !*szShortCutPath)
            return;
        szFullDirPath = MsgPrompt ("Full path: ", "", "");
        if (!szFullDirPath || !*szFullDirPath)
            return;
        WritePrivateProfileString((LPCSTR)"DirChange", (LPCSTR)szShortCutPath,
                              (LPCSTR)szFullDirPath, (LPCSTR)pathName);
        bNew = TRUE;
    }
    else
        GetPrivateProfileString((LPCSTR)"DirChange", (LPCSTR)szShortCutPath,
                              "", cFullDirPath, sizeof (cFullDirPath),
                              (LPCSTR)pathName);

    if (bNew == TRUE)
        SysSetCwd (szFullDirPath);
    else
        SysSetCwd (cFullDirPath);

    retcode = WinExec( "CWSHELL.PIF", SW_SHOWMAXIMIZED);
}


void DLL MHB_ExecWinApp (LPSTR szApp)
{
    int   retcode;
    LPSTR szGetApp;
    LPSTR pattern = _GetHistoryTOS( "SHELLCMND" );

    if (!szApp || !*szApp)
        szGetApp = MsgPopupPromptHistory ("SHELLCMND", "Execute Win App: ",
                                          pattern);
    else
        szGetApp = MsgPopupPromptHistory ("SHELLCMND", "Execute Win App: ",
                                          szApp);

    if (!szGetApp || !*szGetApp)
    {
        MHB_DisplayFileName();
        return;
    }

    if (strnicmp (szGetApp, "?", 1) == 0)
    {
        szGetApp = DlgSelectFilename (NULL, "File to launch", NULL, NULL, 
        0, 0);
    }

    if (!szGetApp || !*szGetApp)
    {
        MHB_DisplayFileName();
        return;
    }

    retcode = WinExec (szGetApp, SW_SHOW);
    MHB_DisplayFileName();
}


// Mike Bailey 24 Oct 95 8:08p
// Add a direct connection to CVW using two entries in the ADDFX.INI
// file for the command line and the working directory.
//
void DLL CVW (void)                             // CTL-D
{
    char  cCommandStr[256];
    char  cWrkDir[256];
    char  cPathName[256];
    LPSTR ptr;

    // Mike Bailey 24 Oct 95 8:48p 
    // Create fully-qualified path to ini file in the CWRIGHT directory.
    //
    ptr = TransformFilename (SysQArgv (0), "%v%p");
    wsprintf (cPathName, "%saddfx.ini", ptr);

    GetPrivateProfileString((LPCSTR)"CVW", (LPCSTR)"CommandLine",
                              "", cCommandStr, sizeof (cCommandStr),
                              (LPCSTR)cPathName);
    if (!cCommandStr || !*cCommandStr)
    {
        MHB_DisplayFileName();
        return;
    }

    GetPrivateProfileString((LPCSTR)"CVW", (LPCSTR)"WorkingDir",
                              "", cWrkDir, sizeof (cWrkDir),
                              (LPCSTR)cPathName);
    if (!cWrkDir || !*cWrkDir)
    {
        MHB_DisplayFileName();
        return;
    }

    // Save the current directory being used by CodeWright..
    //
    ptr = SysQCwd(0);

    // Set the working directory for the source files for CVW and
    // launch CVW.
    //
    SysSetCwd (cWrkDir);
    WinExec (cCommandStr, SW_SHOWMAXIMIZED);

    // Restore the CodeWright directory.
    //
    SysSetCwd (ptr);
    MHB_DisplayFileName();
}


// Mike Bailey 26 Oct 95 10:35p
// Intercede on the WriteBuffer() command to display the filename after
// the write with additional information about the file.
//
void DLL MHB_WriteBuffer (void)                 // ALT-W
{
    DWORD dStart, dEnd;

    WriteBuffer();
    // Mike Bailey 26 Oct 95 10:24p
    // Display the message for one second before continuing.
    dStart = GetTickCount();
    do
    {
        dEnd = GetTickCount();
    }
    while ((dEnd - dStart) < 1000L);
    MHB_DisplayFileName();
}


// Mike Bailey 7 Nov 95 9:23p
// Display a clock.  Check to see if a string already exists on
// the status line.  If so, put the clock update at the start
// of the string and redisplay it.
//
void DLL MHB_DisplayClock (void)
{

    char buf[20];
    char bufLeft[140];
    char bufLast[115];
    struct tm *tmp;
    long lTime;
    LPSTR lPtr;

    time (&lTime) ;
    tmp = localtime (&lTime) ;
    if (tmp->tm_hour >= 12)
    {
        if (tmp->tm_hour > 12)
            tmp->tm_hour -= 12;

      wsprintf(buf, "%2u:%02u:%02up", tmp->tm_hour, tmp->tm_min, tmp->tm_sec);
    }
    else
    {
        if (tmp->tm_hour < 1)
            tmp->tm_hour = 12;

      wsprintf(buf, "%2u:%02u:%02ua", tmp->tm_hour, tmp->tm_min, tmp->tm_sec);
    }

    lstrcpyn (bufLast, MsgQLastStr(), sizeof (bufLast));
    lPtr = _fstrchr (bufLast, ']');
    if (lPtr == NULL)
        lPtr = MsgQLastStr();
    else
        lPtr += 2;
    wsprintf (bufLeft, "[%s] %s", buf, lPtr);
    MsgMessage (bufLeft);
}


// Mike Bailey 13 Feb 96 10:25p 
// The next three functions override the Brief drop bookmark which
// always prompts if you want to overwrite a pre-existing bookmark.
//
void DLL MHB_DropBookMark1 (void)
{
    char msg[50];  // 30 Jan 95 MBailey Add msg to tell what bookmark.

    if (MarkCreateGlobal (1))
    {
        wsprintf (msg, "Bookmark dropped: 1");
        MsgMessage (msg);
    }
    else
        MsgMessage ("Drop bookmark 1 failed.");
}
void DLL MHB_DropBookMark2 (void)
{
    char msg[50];  // 30 Jan 95 MBailey Add msg to tell what bookmark.

    if (MarkCreateGlobal (2))
    {
        wsprintf (msg, "Bookmark dropped: 2");
        MsgMessage (msg);
    }
    else
        MsgMessage ("Drop bookmark 2 failed.");
}
void DLL MHB_DropBookMark3 (void)
{
    char msg[50];  // 30 Jan 95 MBailey Add msg to tell what bookmark.

    if (MarkCreateGlobal (3))
    {
        wsprintf (msg, "Bookmark dropped: 3");
        MsgMessage (msg);
    }
    else
        MsgMessage ("Drop bookmark 3 failed.");
}



